import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

public class Main {
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(new File("DICE.in")));
		int t = Integer.parseInt(in.readLine());
		
		for (int q = 0 ; q < t ; q++) {
			String[] data;
			data = in.readLine().split(" ");
			
			int n = Integer.parseInt(data[0]);
			int m = Integer.parseInt(data[1]);
			
			St[][] A = new St[n][m];
			
			for (int i = 0 ; i < n ; i++) {
				data = in.readLine().split(" ");
				for (int j = 0 ; j < m ; j++) {
					A[i][j] = new St(Integer.parseInt(data[j]));
				}
			}
			
			A[0][0].set(1, 0);A[0][0].set(2, 0);A[0][0].set(3, 0);
			A[0][0].set(4, 0);A[0][0].set(5, 0);A[0][0].set(6, 0);
			
			for (int i = 0 ; i < n ; i++) {
				for (int j = 0 ; j < m ; j++) {
					if (j < (m - 1)) { 
						produce(A[i][j], 1, A[i][j + 1]);
						produce(A[i][j], 2, A[i][j + 1]);
						produce(A[i][j], 3, A[i][j + 1]);
						produce(A[i][j], 4, A[i][j + 1]);
						produce(A[i][j], 5, A[i][j + 1]);
						produce(A[i][j], 6, A[i][j + 1]);
					}
					if (i < (n - 1)) {
						produce(A[i][j], 1, A[i + 1][j]);
						produce(A[i][j], 2, A[i + 1][j]);
						produce(A[i][j], 3, A[i + 1][j]);
						produce(A[i][j], 4, A[i + 1][j]);
						produce(A[i][j], 5, A[i + 1][j]);
						produce(A[i][j], 6, A[i + 1][j]);
					}
				}
			}
			
			int answer = Integer.MIN_VALUE;
			for (int i = 1 ; i < 7 ; i++) {
				answer = Math.max(answer, A[n - 1][m - 1].get(i));
			}
			System.out.println(answer);
		}
	}
	
	public static void produce(St old, int ind, St next) {
		int prev = old.get(ind);
		
		if (ind == 1) {
			next.set(2, prev);
			next.set(3, prev);
			next.set(4, prev);
			next.set(5, prev);
		} else if (ind == 2) {
			next.set(1, prev);
			next.set(3, prev);
			next.set(4, prev);
			next.set(6, prev);
		} else if (ind == 3) {
			next.set(1, prev);
			next.set(2, prev);
			next.set(5, prev);
			next.set(6, prev);
		} else if (ind == 4) {
			next.set(1, prev);
			next.set(2, prev);
			next.set(5, prev);
			next.set(6, prev);
		} else if (ind == 5) {
			next.set(1, prev);
			next.set(3, prev);
			next.set(4, prev);
			next.set(6, prev);
		} else if (ind == 6) {
			next.set(2, prev);
			next.set(3, prev);
			next.set(4, prev);
			next.set(5, prev);
		}
	}
	
	public static class St {
		int[] A = new int[7];
		int n;
		
		public St(int n) {
			this.n = n;
			
			for (int i = 0 ; i < 7 ; i++) {
				A[i] = Integer.MIN_VALUE;
			}
		}
		public int get(int ind) {
			return A[ind];
		}
		public void set(int ind, int prev) {
			int result = ind * n;
			A[ind] = Math.max(A[ind], result + prev);
		}
		@Override
		public String toString() {
			String s = "";
			for (int i = 1 ; i < 7 ; i++) s += (A[i] + " ");
			s += "\n";
			
			return s;
		}
	}
}