import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

public class Main {
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(new File("BUS.in")));
		int t = Integer.parseInt(in.readLine());
		
		for (int q = 0 ; q < t ; q++) {
			String[] data;
			data = in.readLine().split(" ");
			int n = Integer.parseInt(data[0]);
			int m = Integer.parseInt(data[1]);
			
			int[] d = new int[n];
			int[] l = new int[n];
			int[] h = new int[n];
			
			for (int i = 0 ; i < n ; i++) {
				data = in.readLine().split(" ");
				
				d[i] = Integer.parseInt(data[0]);
				l[i] = Integer.parseInt(data[1]);
				h[i] = Integer.parseInt(data[2]);
			}
			
			double[] time = new double[n + 1];
			
			for (int i = 0 ; i < n ; i++) {
				for (int j = 0 ; j < n ; j++) {
					time[i] += d[j] * 1.0f / l[i] + (l[i] > l[j] ? h[j] : 0);  
				}
			}
			
			for (int j = 0 ; j < n ; j++) {
				time[n] += d[j] * 1.0f / m + (m > l[j] ? h[j] : 0);
			}
			
			double answer = Double.MAX_VALUE;
			int answerInd = -1;
			
			for (int i = 0 ; i < n ; i++) {
				if (time[i] < answer) {
					answer = time[i];
					answerInd = i;
				}
			}
			
			if (time[n] < answer) {
				System.out.println(m);
			} else {
				System.out.println(l[answerInd]);
			}
		}
	}
}
