#include <iostream>
#include <algorithm>
#define EPS 1e-12
using namespace std;
int main()
{
	freopen ( "bus.in", "r", stdin );
	int t;
	cin >> t;
	while ( t-- )
	{
		int segm, maxsp, i;
		int di[1010], li[1010], hi[1010], s[1010];
		cin >> segm >> maxsp;
		for ( i = 0; i < segm; i++ )
		{
			cin >> di[i] >> li[i] >> hi[i];
			s[i] = li[i];
		}
		sort ( s, s + segm );
		double mintime = 0;
		int speed = maxsp;
		for ( i = 0; i < segm; i++ )
		{
			if ( maxsp > li[i] )
				mintime += hi[i];
			mintime += (double)di[i] / maxsp;
		}

		for ( int j = segm-1; j >= 0; j-- )
		{
			double time = 0;
			int curspeed = s[j];
			for ( i = 0; i < segm; i++ )
			{
				if ( curspeed > li[i] )
					time += hi[i];
				time += (double) di[i] / curspeed;
			}
			if ( time - mintime < EPS )
			{
				speed = curspeed;
				mintime = time;
			}
		}
	
		cout << speed << endl;
	}

	return 0;
}