#include <cstdio>
#include <algorithm>
#include <iostream>
#include <memory>

using namespace std;

struct seg
{
	long long d,l,h;
	bool operator<(const seg &o) const
	{
		return l>o.l;
	}
	void read()
	{
		cin>>d>>l>>h;
	}
};

void solve()
{
	long long n,m;
	cin>>n>>m;
	seg a[1001];
	long long b[1001];
	memset(b, 0, sizeof(b));
	for(int i = 0; i<n; ++i)
		a[i].read();
	sort(a,a+n);
	for(int i = n-1; i>=0; i--)
	{
		b[i] = a[i].d+b[i+1];
	}
	long long ms = m;
	double s = double(b[0])/m;
	for(int i = 0; i<n; ++i)
	{
		if(a[i].l<m)
			s+=a[i].h;
	}
	for(int i = 0; i<n; ++i)
	{
		if(a[i].l>m)
			continue;
		long long q = a[i].l;
		double t = double(b[0])/q;
		for(int j = i+1; j<n; ++j)
		{
			if(a[j].l<q)
				t+=a[j].h;
		}
		if(t<s)
		{
			s = t;
			ms = q;
		}
	}
	cout<<ms<<'\n';
}

int main()
{
	freopen("bus.in","r",stdin);
	int t;
	scanf("%d",&t);
	while(t--)
		solve();
}