#include <iostream>
#include <algorithm>
#include <memory.h>
#include <stdio.h>
#define ll long long
#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
using namespace std;


ll gcd(ll a, ll b, ll&x, ll&y){
    if(!a){
        x = 0;
        y = 1;
        return b;
    }

    ll x1, y1;
    ll d = gcd(b%a, a, x1, y1);
    y = x1;
    x = (d-a*y)/b;

    return d;
}



bool solve(ll a, ll b, ll w, ll h){
    if(h%a==0 && w%b==0) return true;
    if(h%b==0 && w%a==0) return true;
    ll x,y,d;
    d = gcd(a,b,x,y);
    ll g = d;
    ll k1,k2,z;


        if(x<0){
            k1 = b/g;
            k2 = a/g;
            z = -x/k1;
            x += k1*z;
            y -= k2*z;
            while(x<0){ x+=k1; y-=k2; }
        }
        if(y<0){
            k1 = b/g;
            k2 = a/g;
            z = -y/k2;
            x -= k1*z;
            y += k2*z;
            while(y<0){ x-=k1; y+=k2; }
        }
        if(x<0 || y<0) return false;


    if(w%d==0 && h%a==0 && h%b==0){
        x *= w/d;
        y *= w/d;
        return a*x+b*y==w;
    }
    if(h%d==0 && w%a==0 && w%b==0){
        x *= h/d;
        y *= h/d;
        return a*x+b*y==h;
    }

    return false;
}

int main()
{
   freopen("HOTEL.IN","r",stdin);

    int tt;
    cin>>tt;
    while(tt--){
        ll a,b,w,h;
        cin>>a>>b>>w>>h;

        cout<<(solve(a,b,w,h) ? "YES": "NO")<<endl;
    }

    return 0;
}
