#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
using namespace std;
struct p
{
	int h, d, l;
};
double get_time(const vector<p> &segs, int speed)
{
	double result = 0;
	for(int i = 0 ; i < segs.size(); i++)
	{
		if(speed > segs[i].l)
		{
			result += segs[i].h;
		}
		result += segs[i].d / (double)speed;
	}
	return result;
}

int main()
{
	int i, j, t, n;
	freopen("BUS.IN", "r", stdin);
	const int oo = 2 << 28;
	int speed, mmax;
	double max_time = oo;
	vector<p> segs;
	vector<int> speeds;
	cin >> t;
	while(t--)
	{
		p t;
		t.d = t.l = t.h = 0;
		max_time = oo;
		cin >> n >> mmax;
		speeds.assign(n * 2, 1);
		segs.assign(n, t);
		for(i = 0; i < n; i++)
		{
			cin >> t.d >> t.l >> t.h;
			speeds[i] = (t.l);
			speeds[i+1] = (t.l+1);
			segs[i] = t;
		}
		for(int i = 0 ; i < speeds.size(); i++)
		{
			double some = get_time(segs, speeds[i]);
			if(some < max_time)
			{
				max_time = some;
				speed = speeds[i];
			}
			if(some == max_time)
			{
				speed = max(speed, speeds[i]);
			}
		}
		cout << speed << endl;


	}

	return 0;

}