#include <iostream>
#include <cstdio>
#include <vector>
#include <iomanip>
#include <algorithm>

using namespace std;

struct seg
{
	int d, l;
	double h;
};

void calc()
{
	int n, m;

	cin >> n >> m;

	vector < seg > a(n + 1);

	for (int i = 0; i < n; ++i)
		cin >> a[i].d >> a[i].l >> a[i].h;

	int maxspeed = 0;
	double minhours = -1;

	for (int i = 0; i < n + 1; ++i)
	{
		int currspeed;
		
		if (i == n)
			currspeed = m;
		else
			currspeed = a[i].l;

		if (currspeed > m)
			currspeed = m;

		double currhours = 0;

		for (int j = 0; j < n; ++j)
		{
			currhours += (double)a[j].d / (double)currspeed;

			if (currspeed > a[j].l)
				currhours += a[j].h;
		}
/*
		cout << maxspeed << " " << minhours << endl;
		cout << currspeed << " " << currhours << endl;
*/
		if (minhours < 0)
		{
			minhours = currhours;
			maxspeed = currspeed;
		}
		else
		{
			if (minhours > currhours || (minhours == currhours && maxspeed < currspeed))
			{
				minhours = currhours;
				maxspeed = currspeed;
			}
		}
	}

	cout << maxspeed << endl;
}

int main ()
{
	freopen("bus.in", "r", stdin);

	int n;

	cin >> n;

	for (int i = 0; i < n; ++i)
		calc();

	return 0;
}